SystemOrganization addCategory: #'EsAndEm-Tests'!
SystemOrganization addCategory: #'EsAndEM-Core'!

!Object methodsFor: '*esandem-serializing' stamp: 'cwp 9/4/2008 08:16'!
externalObjects
	^ #()! !

!Object methodsFor: '*esandem-serializing' stamp: 'cwp 8/18/2010 11:09'!
serialize
	^ SMSerializer serialize: self! !

!Object methodsFor: '*esandem-serializing' stamp: 'cwp 9/2/2008 00:35'!
serializeWith: aSerializer
	aSerializer serializeObject: self! !

Object subclass: #SMArchive
	instanceVariableNames: 'bytes external'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMArchive class methodsFor: 'as yet unclassified' stamp: 'cwp 9/8/2008 21:03'!
bytes: aByteArray external: anArray
	^ self new setBytes: aByteArray external: anArray! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 11/4/2008 00:04'!
base64
	^ (Base64MimeConverter mimeEncode: self bytes readStream) contents! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 9/13/2008 23:57'!
bytes
	^ bytes! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 9/8/2008 21:32'!
digest
	| sha |
	sha := SecureHashAlgorithm new.
	^ (sha hashMessage: bytes) printStringHex asLowercase! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 9/23/2008 21:30'!
external
	^ external! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2010 10:42'!
materialize
	^ (SMMaterializer on: bytes readStream)
		external: external;
		materialize! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 9/8/2008 21:04'!
setBytes: aByteArray external: anArray
	bytes := aByteArray.
	external := anArray! !

Object subclass: #SMMaterializer
	instanceVariableNames: 'decoder references external'
	classVariableNames: 'Types'
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 9/1/2008 19:39'!
initialize
	self initializeTypes! !

!SMMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 8/19/2010 10:33'!
initializeTypes
	Types := #(
		materializeByte
		materializeReference
		materializeExternal
		materializeClass
		materializeClass
		materializeClass
		materializeSingleton
		materializeObject
		materializeUtf8String
		materializeUtf16String
		materializeSymbol
		materializeLargeNegativeInteger
		materializeSmallNegativeInteger
		materializeSmallPositiveInteger
		materializeLargePositiveInteger
		materializeFloat
		materializeByteArray
		materializeArray
		materializeSet
		materializeDictionary
		materializeMethodContext
	)! !

!SMMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 8/31/2008 15:57'!
materialize: aByteArray
	^ self materializeFrom: aByteArray readStream! !

!SMMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 8/31/2008 15:59'!
materializeFrom: aReadStream
	| instance |
	instance := self on: aReadStream.
	^ instance materialize! !

!SMMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 8/31/2008 15:56'!
on: aReadStream
	^ self new setStream: aReadStream! !

!SMMaterializer methodsFor: 'private' stamp: 'cwp 9/23/2008 07:42'!
addReference: anObject
	references add: anObject! !

!SMMaterializer methodsFor: 'public' stamp: 'cwp 9/4/2008 08:17'!
external: anArray 
	
	external := anArray! !

!SMMaterializer methodsFor: 'public' stamp: 'cwp 9/1/2008 20:02'!
materialize
	| type selector |
	type := decoder getType.
	selector := Types 
		at: type
		ifAbsent: [ self error: 'unrecognized type' ].
	^ self perform: selector! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/22/2008 22:42'!
materializeArray
	| size array |
	size := self materialize.
	array := Array new: size.
	self addReference: array.
	1 
		to: size
		do: 
			[ : i | 
			array 
				at: i
				put: self materialize ].
	^ array! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:54'!
materializeByte
	^ decoder getByte! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/22/2008 22:42'!
materializeClass
	| name class |
	name := self materialize.
	class := Smalltalk at: name.
	self addReference: class.

	"consume the inst var names"
	self materialize timesRepeat: [ self materialize ].
	^ class! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/22/2008 22:42'!
materializeDictionary
	| size dictionary |
	size := self materialize.
	dictionary := Dictionary new: size.
	self addReference: dictionary.
	size timesRepeat: 
		[ dictionary 
			at: self materialize
			put: self materialize ].
	^ dictionary! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/4/2008 08:18'!
materializeExternal
	| index |
	index := self materialize.
	^ external at: index! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:59'!
materializeFloat
	^ decoder getFloat! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:31'!
materializeLargeNegativeInteger
	| size |
	size := self materialize.
	^ (decoder getIntegerOfSize: size) negated! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:31'!
materializeLargePositiveInteger
	| size |
	size := self materialize.
	^ decoder getIntegerOfSize: size! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 7/12/2010 21:42'!
materializeMethodContext
	| method sender pc stackp closure receiver context |
	context := Object new.
	self addReference: context.
	method := self materialize.
	sender := self materialize.
	pc := self materialize.
	stackp := self materialize.
	closure := self materialize.
	receiver := self materialize.
	context become: (MethodContext newForMethod: method).
	context
		setSender: sender
			receiver: receiver
			method: method
			arguments: #() ;
		pc: pc ;
		stackp: stackp ;
		closure: closure.
	self readPointersInto: context.
	^ context! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 8/19/2010 10:34'!
materializeObject
	| theClass object tmp |
	object := Object new.
	self addReference: object.
	theClass := self materialize.
	tmp := theClass isVariable 
		ifTrue: [ theClass new: self materialize ]
		ifFalse: [ theClass basicNew ].
	object become: tmp.
	1 to: object class instSize do: 
		[ : i | object instVarAt: i put: self materialize ].
	object class isVariable ifTrue: 
		[ object class isPointers 
			ifTrue: [ self readPointersInto: object ]
			ifFalse: [ decoder getBytesInto: object ] ].
	^ object! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/4/2008 08:00'!
materializeReference
	^ references at: self materialize! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/22/2008 22:42'!
materializeSet
	| size set |
	size := self materialize.
	set := Set new: size.
	self addReference: set.
	size timesRepeat: [ set add: self materialize ].
	^ set! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:55'!
materializeSingleton
	^ decoder getSingleton! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:57'!
materializeSmallNegativeInteger
	^ decoder getSmallInteger negated! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:58'!
materializeSmallPositiveInteger
	^ decoder getSmallInteger! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:35'!
materializeSymbol
	^ self materializeUtf8String asSymbol! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:42'!
materializeUtf16String
	| size |
	size := self materialize.
	^ decoder getUtf16StringOfSize: size.
	! !

!SMMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:41'!
materializeUtf8String
	| size |
	size := self materialize.
	^ decoder getUtf8StringOfSize: size.
	! !

!SMMaterializer methodsFor: 'private' stamp: 'cwp 9/3/2008 19:43'!
readPointersInto: anObject 
	
	1	to: anObject size
		do:	[ :i | anObject at: i put: self materialize ]! !

!SMMaterializer methodsFor: 'initialize-release' stamp: 'cwp 8/18/2010 10:43'!
setStream: aStream 
	decoder := SMObjectDecoder on: aStream.
	references := OrderedCollection new! !

Object subclass: #SMObjectDecoder
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMObjectDecoder class methodsFor: 'as yet unclassified' stamp: 'cwp 9/2/2008 07:38'!
on: aReadStream
	^ self new setStream: aReadStream! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 8/31/2008 19:30'!
getByte
	^ stream next! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 00:50'!
getBytesInto: anObject 
	1 
		to: anObject byteSize
		do: 
			[ : index | 
			anObject 
				byteAt: index
				put: stream next ]! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:32'!
getFloat
	| hi lo |
	hi := self getIntegerOfSize: 4.
	lo := self getIntegerOfSize: 4.
	^ (Float basicNew: 2)
		at: 1 put: hi;
		at: 2 put: lo;
		yourself! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:32'!
getIntegerOfSize: size 
	| value |
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: stream next].
	^ value! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 9/1/2008 19:34'!
getSingleton
	| index |
	index := stream next.
	^ #(nil true false) at: index! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 8/31/2008 16:46'!
getSmallInteger
	| hi lo |
	hi := stream next.
	lo := stream next.
	^ (hi bitShift: 8) + lo! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 8/31/2008 16:45'!
getType
	^ stream next! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:44'!
getUtf16StringOfSize: size 
	| string |
	string := WideString new: size.
	1 to: size do: 
		[ :index | 
		string at: index put: self readUtf16Character ].
	^ string! !

!SMObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:43'!
getUtf8StringOfSize: size
	| string |
	string := ByteString new: size.
	1 to: size do: [:index | string at: index put: self readUtf8Character].
	^ string! !

!SMObjectDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:39'!
readTwoBytes
	| hi lo |
	hi := stream next.
	lo := stream next.
	^ (hi bitShift: 8) bitOr: lo! !

!SMObjectDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:37'!
readUtf16Character
	| value |
	value := self readTwoBytes.
	^ (value < 56320 or: [ value > 57343 ]) 
		ifTrue: [ Unicode value: value ]
		ifFalse: [ self readUtf16CharacterGiven: value ]! !

!SMObjectDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:44'!
readUtf16CharacterGiven: first
	| second |
	second := self readTwoBytes.
	^ Unicode value: ((first bitShift: 10) bitOr: second) + 16r10000! !

!SMObjectDecoder methodsFor: 'private' stamp: 'cwp 9/9/2008 08:00'!
readUtf8Character
	| value |
	value := stream next.
	value <= 127 
		ifTrue: [ ^ Unicode value: value ]
		ifFalse: 
			[value <= 223 
				ifTrue: 
					[ value := (value bitAnd: 31) bitShift: 6.
					value := value bitOr: (stream next bitAnd: 63)]
				ifFalse: 
					[ value := (value bitAnd: 15) bitShift: 12.
					value := value bitOr: ((stream next bitAnd: 63) bitShift: 6).
					value := value bitOr: (stream next bitAnd: 63)].
			^ Unicode value: value ]! !

!SMObjectDecoder methodsFor: 'initialize-release' stamp: 'cwp 9/2/2008 07:38'!
setStream: aReadStream 
	stream := aReadStream.
! !

Object subclass: #SMObjectEncoder
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

SMObjectEncoder class
	instanceVariableNames: 'stream'!

SMObjectEncoder class
	instanceVariableNames: 'stream'!

!SMObjectEncoder class methodsFor: 'as yet unclassified' stamp: 'cwp 8/31/2008 16:30'!
on: aWriteStream
	^ self new setStream: aWriteStream! !

!SMObjectEncoder methodsFor: 'public' stamp: 'cwp 8/31/2008 19:24'!
putByte: anInteger
	stream nextPut: anInteger! !

!SMObjectEncoder methodsFor: 'public' stamp: 'cwp 9/2/2008 00:44'!
putBytesFrom: anObject
	1 
		to: anObject byteSize 
		do: [:index | stream nextPut: (anObject byteAt: index)]! !

!SMObjectEncoder methodsFor: 'public' stamp: 'cwp 8/31/2008 20:19'!
putFloat: aFloat
	self write32BitInteger: (aFloat at: 1).
	self write32BitInteger: (aFloat at: 2).! !

!SMObjectEncoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:24'!
putLargeInteger: anInteger size: size
	| byte |
	(size - 1 to: 0 by: -1) do:
		[:index |
		byte := (anInteger bitShift: index * -8) bitAnd: 255.
		stream nextPut: byte]! !

!SMObjectEncoder methodsFor: 'public' stamp: 'cwp 9/1/2008 19:33'!
putSingleton: anObject
	| index |
	index := #(nil true false) indexOf: anObject.
	stream nextPut: index! !

!SMObjectEncoder methodsFor: 'public' stamp: 'cwp 8/18/2010 11:26'!
putSmallInteger: anInteger
	stream nextPut: (anInteger bitShift: -8).
	stream nextPut: (anInteger bitAnd: 255). ! !

!SMObjectEncoder methodsFor: 'public' stamp: 'cwp 8/31/2008 16:28'!
putType: aByte
	stream nextPut: aByte! !

!SMObjectEncoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:25'!
putUtf16String: aString
	| value |
	aString do:
		[:char |
		value := char asUnicode.
		value < 16r10000 
			ifTrue: [self writeTwoByteCode: value]
			ifFalse: [self writeFourByteCode: value]]! !

!SMObjectEncoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:25'!
putUtf8String: aString
	
	aString do: [ :char | self writeUtf8Code: char asUnicode ]! !

!SMObjectEncoder methodsFor: 'initialize-release' stamp: 'cwp 8/31/2008 16:30'!
setStream: aWriteStream
	stream := aWriteStream! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 20:18'!
write32BitInteger: anInteger
	stream		
		nextPut: (anInteger bitShift: -24);
		nextPut: ((anInteger bitShift: -16) bitAnd: 255);
		nextPut: ((anInteger bitShift: -8) bitAnd: 255);
		nextPut: (anInteger bitAnd: 255)! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:28'!
writeFourByteCode: anInteger
	| value |
	value := 16r10000 - anInteger.
	stream nextPut: ((value bitShift: -18) bitOr: 16rD8).
	stream nextPut: ((value bitShift: -10) bitAnd: 16rFF).
	stream nextPut: ((value bitShift: -8) bitOr: 16rDC).
	stream nextPut: (value bitAnd: 16rFF).
	

! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:27'!
writeTwoByteCode: value
	stream nextPut: (value bitShift: -8).
	stream nextPut: (value bitAnd: 16rFF).! !

!SMObjectEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:23'!
writeUtf8Code: value
	value <= 16r7F
		ifTrue: [stream nextPut: value]
		ifFalse:
			[value <= 16r7FF
				ifTrue: 
					[stream nextPut: ((value bitShift: -6) bitOr: 16rC0).
					stream nextPut: ((value bitAnd: 16r3F) bitOr: 16r80)]
				ifFalse:
					[value <= 16rFFFF
						ifTrue:
							[stream nextPut: ((value bitShift: -12) bitOr: 16rE0).
							stream nextPut: (((value bitShift: -6) bitAnd: 16r3F) bitOr: 16r80).
							stream nextPut: ((value bitAnd: 16r3F) bitOr: 16r80)]]]! !

Object subclass: #SMObjectWithExternalState
	instanceVariableNames: 'alpha beta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEm-Tests'!

!SMObjectWithExternalState methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2008 07:35'!
alpha
	^ alpha! !

!SMObjectWithExternalState methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2008 07:35'!
beta
	^ beta! !

!SMObjectWithExternalState methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2008 07:31'!
externalObjects
	^ {beta}! !

!SMObjectWithExternalState methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2008 07:31'!
initialize
	alpha := ValueHolder new
		contents: #alpha;
		yourself.
	
	beta := ValueHolder new
		contents: #beta;
		yourself! !

Object subclass: #SMSerializer
	instanceVariableNames: 'encoder external references count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMSerializer class methodsFor: 'instance creation' stamp: 'cwp 8/31/2008 15:47'!
on: aWriteStream
	^ self new setStream: aWriteStream! !

!SMSerializer class methodsFor: 'serializing' stamp: 'cwp 8/18/2010 10:42'!
serialize: anObject
	| stream external |
	stream := (ByteArray new: 100) writeStream.
	external := self serialize: anObject on: stream.
	^ SMArchive bytes: stream contents external: external! !

!SMSerializer class methodsFor: 'serializing' stamp: 'cwp 8/18/2010 10:42'!
serialize: anObject external: aDictionary
	| stream external |
	stream := (ByteArray new: 100) writeStream.
	external := self serialize: anObject external: aDictionary on: stream.
	^ SMArchive bytes: stream contents external: external! !

!SMSerializer class methodsFor: 'serializing' stamp: 'cwp 9/21/2008 00:37'!
serialize: anObject external: aDictionary on: aWriteStream
	^ (self on: aWriteStream)
		external: aDictionary;
		serialize: anObject;
		external! !

!SMSerializer class methodsFor: 'serializing' stamp: 'cwp 9/21/2008 00:25'!
serialize: anObject on: aWriteStream
	^ self 
		serialize: anObject 
		external: IdentityDictionary new 
		on: aWriteStream! !

!SMSerializer methodsFor: 'public' stamp: 'cwp 9/4/2008 07:48'!
external
	| array |
	array := Array new: external size.
	external keysAndValuesDo:
		[:object :i | array at: i put: object].
	^ array! !

!SMSerializer methodsFor: 'public' stamp: 'cwp 9/21/2008 00:18'!
external: aDictionary
	external := aDictionary! !

!SMSerializer methodsFor: 'private' stamp: 'cwp 9/4/2008 08:03'!
indexOf: anObject in: anIndex ifPresent: pBlock ifAbsent: aBlock
	| id |
	(anIndex includesKey: anObject)
		ifTrue: 
			[id := anIndex at: anObject.
			pBlock value: id]
		ifFalse:
			[id := anIndex size + 1.
			anIndex at: anObject put: id.
			aBlock value: id].
	
		! !

!SMSerializer methodsFor: 'public' stamp: 'cwp 8/31/2008 21:21'!
serialize: anObject
	anObject serializeWith: self! !

!SMSerializer methodsFor: 'private' stamp: 'cwp 9/4/2008 08:03'!
serialize: anObject with: aBlock 
	self 
		indexOf: anObject
		in: references
		ifPresent: [:id | self serializeReference: id ]
		ifAbsent: [:id | aBlock value]! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 9/3/2008 19:18'!
serializeArray: anArray
	self serialize: anArray with:
		[encoder putType: 18.
		self serialize: anArray size.
		anArray do: [:ea | self serialize: ea]]! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:21'!
serializeByte: anInteger 
	encoder putType: 1.
	encoder putByte: anInteger.
	! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 9/3/2008 23:10'!
serializeClass: aClass
	| type vars |
	
	self serialize: aClass with: 

		[type :=  aClass isVariable 
			ifFalse: [4]				"named inst vars only"
			ifTrue: 
				[aClass isPointers 
					ifTrue: [5]		"named + indexed object references"
					ifFalse: [6]].	"bytes or words"
		
		encoder putType: type.
		vars := aClass allInstVarNames.
		self serialize: aClass name.
		self serialize: vars size.
		vars do: [:ea | self serialize: ea]]! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 9/3/2008 19:22'!
serializeDictionary: aDictionary

	self serialize: aDictionary with:
		[encoder putType: 20.
		self serialize: aDictionary size.
		aDictionary keys asArray sort do:
			[:key |
			self serialize: key.
			self serialize: (aDictionary at: key)]]! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 9/4/2008 08:16'!
serializeExternal: anObject
	| index |
	self
		indexOf: anObject
		in: external
		ifPresent: [:id | index := id]
		ifAbsent: [:id | index := id].
	encoder putType: 3.
	self serialize: index! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 8/31/2008 19:51'!
serializeFloat: aFloat
	encoder putType: 16.
	encoder putFloat: aFloat! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:20'!
serializeInteger: anInteger 
	anInteger < -65535 ifTrue: 
		[ ^ self 
			writeLargeInteger: anInteger negated
			type: 12 ].
	anInteger < 0 ifTrue: [ ^ self serializeSmallNegativeInteger: anInteger ].
	anInteger < 256 ifTrue: [ ^ self serializeByte: anInteger ].
	anInteger < 65535 ifTrue: [ ^ self serializeSmallPositiveInteger: anInteger ].
	self 
		writeLargeInteger: anInteger
		type: 15! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 7/12/2010 19:58'!
serializeMethodContext: aContext
	self serialize: aContext with:
		[encoder putType: 22.
		self serialize: aContext method.
		self serialize: aContext sender.
		self serialize: aContext pc.
		self serialize: aContext stackPtr.
		self serialize: aContext closure.
		self serialize: aContext receiver.
		self writePointersFrom: aContext external: #()]! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 7/14/2010 11:16'!
serializeObject: anObject 

	| ext |
	self serialize: anObject with: 
		[ext := anObject externalObjects.
		encoder putType: 8.
		self serialize: anObject class.
		anObject class isVariable ifTrue: [self serialize: anObject size].
		1	to: anObject class instSize
			do: [:i | self writeChild: (anObject instVarAt: i) external: ext].
		anObject class isVariable ifTrue: 
			[anObject class isPointers 
				ifTrue: [self writePointersFrom: anObject external: ext]
				ifFalse: [encoder putBytesFrom: anObject]]]! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 9/3/2008 19:15'!
serializeReference: anInteger
	encoder putType: 2.
	self serialize: anInteger! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 9/3/2008 19:26'!
serializeSet: aSet
	self serialize: aSet with:
		[encoder putType: 19.
		self serialize: aSet size.
		aSet do: [:ea | self serialize: ea]]! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:36'!
serializeSingleton: aBoolean
	encoder putType: 7.
	encoder putSingleton: aBoolean! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:20'!
serializeSmallNegativeInteger: anInteger 
	encoder putType: 13.
	encoder putSmallInteger: anInteger abs.
	! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:20'!
serializeSmallPositiveInteger: anInteger 
	encoder putType: 14.
	encoder putSmallInteger: anInteger.
	! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:26'!
serializeSymbol: aSymbol
	encoder putType: 11.
	self serialize: aSymbol size.
	encoder putUtf8String: aSymbol! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:25'!
serializeUtf16String: aString
	encoder putType: 10.
	self serialize: aString size.
	encoder putUtf16String: aString! !

!SMSerializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:25'!
serializeUtf8String: aString
	encoder putType: 9.
	self serialize: aString size.
	encoder putUtf8String: aString! !

!SMSerializer methodsFor: 'initialize-release' stamp: 'cwp 8/18/2010 11:12'!
setStream: aWriteStream 
	encoder := SMObjectEncoder on: aWriteStream.
	references := IdentityDictionary new.
	external := IdentityDictionary new.
! !

!SMSerializer methodsFor: 'private' stamp: 'cwp 9/4/2008 08:12'!
writeChild: anObject external: ext
	
	(ext includes: anObject)
		ifTrue: [self serializeExternal: anObject]
		ifFalse: [self serialize: anObject]! !

!SMSerializer methodsFor: 'private' stamp: 'cwp 9/2/2008 07:23'!
writeLargeInteger: anInteger type: type 
	| size |
	encoder putType: type.
	size := (anInteger log: 256) floor + 1.
	self serialize: size.
	encoder putLargeInteger: anInteger size: size.
	^ self! !

!SMSerializer methodsFor: 'private' stamp: 'cwp 9/4/2008 08:13'!
writePointersFrom: anObject external: ext
	
	1 to: anObject size do: 
		[:i | self writeChild: (anObject at: i) external: ext]
		! !

TestCase subclass: #SMSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEm-Tests'!

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 9/2/2008 00:30'!
assertEqualityOf: expected
	^ self 
		assertEquivalenceOf: expected 
		with: [:actual | actual = expected]! !

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 9/5/2008 07:55'!
assertEquivalenceOf: expected with: aBlock
	self 
		examineResultOf: expected 
		with: 
			[:actual | 
			self assert: (aBlock value: actual)]! !

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 8/31/2008 23:00'!
assertIdentityOf: expected
	^ self
		assertEquivalenceOf: expected
		with: [:actual | actual == expected]! !

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 9/23/2008 21:03'!
createSubcontinuation
	| subcontinuation |
	subcontinuation := ALSubcomputation do: 
		[ : p | 
		self 
			doSubcomp: 3
			with: [ p escape: [ : k | k ] ] ].
	^ subcontinuation! !

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 9/19/2008 08:01'!
doSubcomp: anInteger with: aBlock
	^ anInteger = 0
		ifTrue: aBlock
		ifFalse: [(self doSubcomp: anInteger - 1 with: aBlock) + 1]! !

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 9/8/2008 21:17'!
examineResultOf: expected with: aBlock
	| actual archive |
	archive := expected serialize.
	actual := archive materialize.
	aBlock value: actual! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/8/2008 19:13'!
testArchive
	| archive |
	archive := 3 serialize.
	self assert: archive materialize = 3! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 20:43'!
testArray
	self assertEqualityOf: #(1 'two' 3.0)! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 19:24'!
testByte
	self assertEqualityOf: 42! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/2/2008 07:09'!
testBytesObject
	self assertEqualityOf: UUID new! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/14/2008 00:22'!
testCallback
	| callback holder |
	holder := ValueHolder new.
	holder contents: 3.
	callback := [ holder contents: 4 ].
	callback fixCallbackTemps.

	self 
		examineResultOf: {holder. callback}
		with: 
			[ :result | 
			result second value.
			self assert: result first contents = 4].
	! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 23:02'!
testClass
	self assertIdentityOf: self class! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/23/2008 21:08'!
testCompiledMethod
	self assertIdentityOf: thisContext method.
	! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 19:57'!
testCyclicalReferenceArray
	| object |
	object := Array new: 1.
	object at: 1 put: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | actual first == actual]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 20:06'!
testCyclicalReferenceDictionary
	| object |
	object := Dictionary new: 1.
	object at: #one put: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | (actual at: #one) == actual]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 20:16'!
testCyclicalReferenceObject
	| object |
	object := ValueHolder new.
	object contents: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | actual contents == actual]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 19:58'!
testCyclicalReferenceSet
	| object |
	object := Set new: 1.
	object add: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | actual anyOne == actual]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/2/2008 22:22'!
testDictionary
	| dict |
	dict := Dictionary new
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3;
		yourself.
	self assertEqualityOf: dict! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/8/2008 21:33'!
testDigest
	| archive |
	archive := 3 serialize.
	self assert: archive digest = 'df2b71f6eb25b9768ff32a8105911d193a350eb8'! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/18/2010 12:34'!
testExternalObject
	| object |
	object := SMObjectWithExternalState new.
	self 
		assertEquivalenceOf: object
		with: 
			[:actual |
			actual alpha ~~ object alpha
				and: [actual beta == object beta]]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 19:34'!
testFalse
	self assertIdentityOf: false! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 19:50'!
testFloat
	self assertEqualityOf: 3.4! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 17:28'!
testLargeNegativeInteger
	self assertEqualityOf: -65536! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 17:28'!
testLargePositiveInteger
	self assertEqualityOf: 65536! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 21:15'!
testLongString
	| string |
	string := String new: 300.
	string atAllPut: $a.
	self assertEqualityOf: string! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 21:59'!
testMultiString
	| ws |
	ws := WideString fromString: 'abc'.
	ws ifNotNil: [self assertEqualityOf: ws]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 19:34'!
testNil
	self assertIdentityOf: nil! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 01:13'!
testObject
	self 
		assertEquivalenceOf: self 
		with: 
			[:actual |
			actual class = self class
				and: [actual selector = self selector]]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/13/2008 00:21'!
testOrderedCollection
	self assertEqualityOf: OrderedCollection new! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/2/2008 22:06'!
testSet
	self assertEqualityOf: #(1 'two' 3.0) asSet! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 16:52'!
testSmallNegativeInteger
	self assertEqualityOf: -300! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 16:52'!
testSmallPositiveInteger
	self assertEqualityOf: 300! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 22:00'!
testString
	self assertEqualityOf: 'abc'.! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 22:00'!
testStringWithAccent
	self assertEqualityOf: 'bc'.! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/23/2008 21:03'!
testSubcontinuation
	| archive subcontinuation |
	subcontinuation := self createSubcontinuation.
	archive := subcontinuation serialize.
	self assert: (archive materialize value: 4) = 7! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 00:04'!
testSymbol
	self assertIdentityOf: #one! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 19:26'!
testTrue
	self assertIdentityOf: true! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 7/14/2010 11:04'!
testVariablePointerObject
	| expected |
	expected := (SparseLargeTable new: 3)
		at: 1 put: $a;
		at: 2 put: $b;
		at: 3 put: $c;
		yourself.

	self 
		assertEquivalenceOf: expected 
		with: 
			[:actual |
			actual class = expected class
				and: [actual = expected]]! !

!ContextPart methodsFor: '*esandem-accessing' stamp: 'cwp 9/18/2008 00:57'!
externalObjects
	^ {self method}! !
SMMaterializer initialize!
